#pragma once

// C++ system level
// #include <string>
// #include <cstring>     // memset, strncmp
// #include <cstdlib>     // TODO: is this for memcpy?
// #include <functional>

// ESP32 specific
// #include "esp_err.h"
#include "esp_log.h"
// #include "driver/gpio.h"
// #include "driver/uart.h"

// project specific
#include "SpiderLib/NumberTypes.hpp"

// qthing stuff
// #include <qthing>

/*
namespace SiliconTorch {

  // CapabilityManager
  namespace CapMan {


    enum ColorType {
      RGB,
      RGBW,
      RGBWYU,
      Greyscale,
      CyanLight,   // Like GreyScale but with differently colored Pixels
      Monochrome,
    };


    class CapMan {

      public:



        void registerLEDStrip(std::string& name, u16 startIdx, u16 length, ColorType);



        // void registerExtension(std::string& name);
        // void registerExtension(std::string& name, std::initializer_list<std::pair<>> properties);




        void publish();


        // ⬇⬇ Singleton stuff ⬇⬇

        static CapMan& instance() {
          static CapMan _instance;
          return _instance;
        }

        CapMan(CapMan const&)         = delete;
        void operator=(CapMan const&) = delete;

        // ⬆⬆ Singleton stuff ⬆⬆

      private:



    };

  }
}
*/